import 'package:json_annotation/json_annotation.dart';
import 'package:lori_sdk/data/models/v2/category.dart' as categoryV2;

part 'category.g.dart';

@JsonSerializable()
class Category {
  Category();

  String id;
  String name;
  String description;
  String imageUrl;
  String iconUrl;
  int productCount;
  String hexColor;

  static Category fromV2(categoryV2.Category categoryV2) {
    var category = Category();
    category.id = categoryV2.id;
    category.name = categoryV2.name;
    category.description = categoryV2.description;
    category.imageUrl = categoryV2.imageUrl;
    category.iconUrl = categoryV2.iconUrl;
    category.productCount = categoryV2.productCount;
    return category;
  }

  factory Category.fromJson(Map<String, dynamic> json) =>
      _$CategoryFromJson(json);

  Map<String, dynamic> toJson() => _$CategoryToJson(this);
}
