import 'package:json_annotation/json_annotation.dart';
import 'package:lori_sdk/data/models/v2/category.dart' as categoryV2;

part 'subcategory.g.dart';

@JsonSerializable()
class Subcategory {
  Subcategory();

  String id;
  String name;
  int productCount;
  String description;
  String hexColor;
  bool hasChildren;

  static Subcategory fromV2(categoryV2.Category categoryV2) {
    var category = Subcategory();
    category.id = categoryV2.id;
    category.name = categoryV2.name;
    category.description = categoryV2.description;
    category.productCount = categoryV2.productCount;
    category.hasChildren = categoryV2.hasChildren;
    return category;
  }

  factory Subcategory.fromJson(Map<String, dynamic> json) =>
      _$SubcategoryFromJson(json);

  Map<String, dynamic> toJson() => _$SubcategoryToJson(this);
}
