import 'dart:async';

import 'package:lori_sdk/data/database/interfaces/notificationDao.dart';

class NotificationSingleton {
  // Singleton part
  static final NotificationSingleton _singleton =
      NotificationSingleton._internal();

  factory NotificationSingleton() {
    return _singleton;
  }

  NotificationSingleton._internal();

  // Class part
  // ignore: close_sinks
  var _notificationStream = StreamController<int>.broadcast(sync: true);

  Future<StreamSubscription<int>> registerToStream(Function callback) async {
    StreamSubscription<int> subscription =
        _notificationStream.stream.listen(callback);
    // Make sure to call cart changed this time
    var count = await NotificationDao().get(false);
    notificationNumberChanged(count.length);
    return subscription;
  }

  void notificationNumberChanged(int count) {
    _notificationStream.sink.add(count);
  }

  void userClose() async {
    await _notificationStream.sink.close();
  }
}
