import 'package:json_annotation/json_annotation.dart';

part 'userAddress.g.dart';

@JsonSerializable()
class UserAddress {
  UserAddress();

  String id;
  String label;
  String cep = '';
  String street = '';
  String neighborhood = '';
  String number = '';
  String complement = '';
  String city = '';
  String state = '';
  String landmark = '';
  bool isPrimary;
  double latitude;
  double longitude;
  bool isDeleted;

  String lineOne() {
    var lineMembers = [street, number, complement, cep, landmark];
    var lineOne = '';
    for (var member in lineMembers) {
      if (member != null && member != '-' && member != '') {
        if (lineOne != '') lineOne += ', ';
        lineOne += member;
      }
    }
    return lineOne;
  }

  String lineTwo() {
    var lineMembers = [neighborhood, city, state];
    var lineTwo = '';
    for (var member in lineMembers) {
      if (member != null && member != '-' && member != '') {
        if (lineTwo != '') lineTwo += ', ';
        lineTwo += member;
      }
    }
    return lineTwo;
  }

  String full() {
    var firstLine = lineOne();
    var secondLine = lineTwo();
    if (firstLine.isEmpty)
      return secondLine;
    else
      return firstLine + " | " + secondLine;
  }

  factory UserAddress.fromJson(Map<String, dynamic> json) =>
      _$UserAddressFromJson(json);

  Map<String, dynamic> toJson() => _$UserAddressToJson(this);
}
